## You want to contribute some code?

First of all: thank you for contributing to this repository. We are always looking for quality contributions and will be happy to accept your pull requests as long as they adhere to some basic rules:

* Please make sure that your contribution fits well in the project's context:
  * We are aiming to provide a high quality multi-platform system information library.
  * This package should stay without any dependencies on any external JavaScript library.

* Please assure that you are submitting quality code, specifically make sure that:
  * Your commits should not be breaking changes - if possible.
  * Your PR are well tested - if possible on multiple platforms / machines (please provide information against what systems it was tested).
  * If your commit needs a major version bump (breaking change), please leave a clear message in your comments. We try to keep the breaking changes as low as possible to avoid compatibility issues.
